#! /usr/bin/perl -w

# use strict;

# 	Invocation parameters:
#	1. File(s) containing CDG2 annotation from which to extract the thematic roles assignments.

my $old_word_number = 2;
my $new_word_number;
my $word;
my @sentence;
my $sentence_counter;
my $line;

my %attachments = (   	"SUBJ" 		=> { }, 
				"OBJA"        	=> { },
				"OBJD"        	=> { }, 
				"AGENT"       	=> { }, 
				"THEME"       	=> { },
				"INSTRUMENT"  	=> { },
				"COMITATIVE" 	=> { }, 
				"RECIPIENT"   	=> { },
				"OWNER"   	  	=> { },
			);
				
while ( <> )
{	
	# If the next line is a separator it is also the end of a block of sentences.
	print "================================\n\n" & next if ( /====/ );
	
	if ( /\s+[0-9]+ (\d+) ([\w,.:;:!?']+)/io ) 	# This matches an annotation header line.
	{	
		$new_word_number = $1;			
		$word = $2;
		$old_word_number = $new_word_number;
		push @sentence, $word; 
	}
	elsif ( /[A-Z]{3,4} -> ([A-Z]+) -> \d+ \/\/ ([\w,.:;:!?']+)/o ) # \/\/ ([\w,.:;:!?']+)/o ) # This matches an annotation label assignment.
	{
		if ( $attachments{ $1 } )
		{
			$attachments{ $1 }{ $word } = $2 if ( defined $attachments{ $1 } );
			# Note that we only want to record attachments for those labels which have their own hash defined above.
		
		}
	}
	elsif( /^;$/ )	# This matches the end of the sentence in the annotation file.
	{
		$sentence_counter ++;
		print $sentence_counter, "\t", join " ", @sentence, "\n";
		
		# Print all the attachments.
		for my $label ( sort keys %attachments )
		{
			for my $key ( keys %{ $attachments{ $label } } )
			{
				printf "\t%-10s \t%-5s --> \t$attachments{ $label }{ $key }\n", $label, $key;
			}
		}
		print "\n";
		
		
		# Now clear all the variable containers for the next sentence.
		@sentence = ();
		
		for my $label ( keys %attachments )
		{
			%{ $attachments{ $label } } = ();
		}
	}
}

print "================================\n\n";