#!/usr/bin/env perl
# /home/foth/dawai/bin/stoptest.pl

use warnings;
use strict;

# find each instance of sshd that has spawned something that has
# spawned cdgp, and kill it.

our @hosts;

if( -r 'HOSTS') {
  my %h;
  open(HOSTS, "HOSTS") or die "Can't read `HOSTS': $!\n";
  while(<HOSTS>) {
    chomp;
    $h{$_}++;
  }
  close(HOSTS);
  @hosts = keys %h;
}

else { @hosts = `uname -n` =~ /^Siemens$/ ?  qw(Siemens) : 
  qw ( node1 node2 node3 node4 node5 node6 node7 node8 node9 ); }


our %table;
our $self = `uname -n`;
HOST:
for (@hosts) {

  my $h = $_;
  my $ssh_magic = '';

  if($self !~ /^node/) {

    if($h =~ /node(\d)$/) {
      $ssh_magic = "-p 200$1";
      $h = 'nats47';
    } elsif($h =~ /node(\d\d)/) {
      $ssh_magic = "-p 20$1";
      $h = 'nats47';
    }
  }

  %table = ();
  print "Executing: ssh $ssh_magic $h ps -fade |\n";
  open(CMD, "ssh $ssh_magic $h ps -fade |") or die "Can's ssh to $h: $!";
  while(<CMD>) {
    if( my($pid,$ppid,$prog) = /^\S+\s+(\d+)\s+(\d+).+\d\d:\d\d:\d\d (.+)$/ ) {
      $table{$pid} = { parent=>$ppid, prog=>$prog };
    }
  }
  while( my($k,$v) = each %table) {

    if($v->{prog} =~ /^sh .+part(\d+)\.sh$/) {
      print "killing part $1: $k $v->{prog}\n";
      system "ssh $ssh_magic $h kill $k";
    }
  }
  system "ssh $ssh_magic $h slay cdgp";
}
system "rm cdg*[0-9]";
print "Deleting incomplete logs...\n";
system 'delete-incomplete-logs.sh'
