#! /usr/bin/perl -w

use strict;
use locale;

#	This script extracts a set of sentence annotations from a CDG annotation file.
#	The numbers of the sentences to extract are obtained from an input file.
#
#	Invocation Arguments
#	====================
#	1. CDG annotation file from which to extract.
#	2. File(s) containing the sentence numbers to extract or sentence numbers to extract.


my %extract;

open ANNOTATIONS, "<", shift @ARGV;

for my $argument ( @ARGV )
{
	if ( -f $argument ) 
	{
		open EXTRACT, "<", $argument or die "Could not open the file $argument.";
		while ( <EXTRACT> )
		{
			chomp;
			$extract{ $_ } ++ ;
		}
	}
	else
	{
		$extract{ $argument } ++ ;	
	}
}

print "There are ", scalar keys %extract, " sentences to extact.\n";

my $counter = 0;

while ( <ANNOTATIONS> )
{
     $counter ++ if /wordgraph/o;
     print if ( $extract{ $counter } );
} 
