#! /usr/bin/perl -w

use strict;

#	This script includes or removes block comments in CDG files. 
#
# 	Invocation arguments:
#	=====================
# 	1. Mode ( '+' to add comments, '-' to remove comments.)
#	2. Start Line
#	3. End Line
# 	4. File Name

my $mode = shift @ARGV;
# The mode determines whether a comment is added to or removed from the file.
# '+' is for adding and '-' for removing a block comment.

my $start_line = shift @ARGV;
my $end_line = shift @ARGV;
my $line_counter;

$^I="";


if( $mode eq "+" )
{
	while ( <> )
	{
		$line_counter ++;
		s/(^.*)/\/\/\t\t$1/ if( $line_counter >= $start_line && $line_counter <= $end_line );
		print;
	}
}
elsif( $mode eq "-" )
{
	while ( <> )
	{
		$line_counter ++;
		s/^\s*\/\/\t\t(.*)/$1/ if( $line_counter >= $start_line && $line_counter <= $end_line );
		print;
	}
}