package cia_components.ppc;

import java.util.*;

import org.semanticweb.owl.model.OWLDescription;
import org.semanticweb.owl.model.OWLClass;

import cia_components.ppc.Score_Assigner;
// import edu.stanford.smi.protegex.owl.model.OWLNamedClass;
// import edu.stanford.smi.protegex.owl.model.OWLRestriction;

public class Output
{
	Score_Assigner score_assigner;
	Sentence sentence;
	
	Set <String> thematic_roles;
	
	String thematic_role_probe, class_name_probe, entity_instance_probe, relation_probe, situation_instance_probe;

	public Output( Score_Assigner assigner )
	{	
		set_Score_Assigner( assigner );
		
		set_Sentence();
	
		set_Thematic_Roles();
		
		set_Probes( "AGENT", "Situation", "test.agent_01", "is_Lexicalisation_for", "test.situation_01" );
		
		// set_Probes( "AGENT", "Painter.f", "Painter.f_001", "is_AGENT_for", "jmd.etw.stehlen_001" );
				
		//========== OUTPUT FRAGMENTS UNDER CONSTRUCTION:
		
		// print_Class_Collection( "Class: ", score_assigner.get_All_Classes() );
		
		// print_Hypothesised_Attachments();
			
		
		
		//========== WORKING OUTPUT FRAGMENTS:
		
		String ppc_integration_mode = System.getenv( "PPC_INTEGRATION_MODE" );
		
		// System.out.println( "PPC Integration Mode: " + ppc_integration_mode );
		
		if( ppc_integration_mode.equals( "1" ) | ppc_integration_mode.equals( "2" ) )
		{
			print_PPC_Output_By_Homonym();
		}
		else if( ppc_integration_mode.equals( "3" ) | ppc_integration_mode.equals( "4" ) )
		{
			print_PPC_Output_By_Slot();
		}
		
		provide_Additional_Debug_Output();
	}
	
	
	private void provide_Additional_Debug_Output()
	{	
//		print_Any_Collection( "", "PPC Input Received from CDG Main", score_assigner.get_Sentence().get_Input_From_CDG_Main() );
//		
//		print_Any_Collection( "Individual: ", "Asserted Individuals in Context Model", score_assigner.get_Asserted_Individuals() );
//		
//		print_Any_Collection( "Individual Name: ", "Asserted Individual Names in the OWLModel", score_assigner.get_Asserted_Individual_Names() );
//		
//		print_Any_Collection( "OWL Class: ", "Asserted OWL Classes in the Context Model", score_assigner.get_Asserted_OWL_Classes() );
//
//		print_Any_Collection( "OWL Class Name: ", "Asserted Class Names in the OWLModel", score_assigner.get_Asserted_OWL_Class_Names() );
//		
//		System.out.println( "Number of Classes in the OWL Model: " + score_assigner.get_Number_of_Asserted_OWL_Classes() );
//
// 		print_Any_Collection( "Relation: ", "All Asserted Relations in the OWLModel", score_assigner.get_Asserted_OWL_Relations() );
//		
//		print_Any_Collection( "Relation Name: ", "All Asserted Relation Names in the OWLModel", score_assigner.get_Asserted_OWLRelation_Names() );
//		
//		// print_Any_Collection( "Thematically Relevant Individual: ", "Thematically Relevant Individuals in the OWLModel", score_assigner.get_All_Inferred_Thematically_Relevant_Individuals() );
//
//		print_Any_Collection( "Thematically Relevant Individual Name: ", "All Thematically Relevant Individual Names in the OWLModel", score_assigner.get_Thematically_Relevant_Individual_Names() );
//
//		print_Any_Collection( "Restriction: ", "All Direct Restrictions for Class '" + class_name_probe + "'", score_assigner.get_Direct_Restrictions_for( class_name_probe ) );
//					
//		print_Any_Collection( "Asserted Individual: ", "All Asserted Individuals of Class '" + class_name_probe + "'", score_assigner.get_Asserted_Individuals_of( class_name_probe ) );
//		
//		print_Any_Collection( "Inferred Individual: ", "All Inferred Individuals of Class '" + class_name_probe + "'", score_assigner.get_Inferred_Individuals( class_name_probe ) );
//	
//		System.out.println( "\nOWL Named Class '" + class_name_probe + "' has a named superclass: " + score_assigner.has_Superclass( class_name_probe ) + ".\n" );
//		
//		
//		print_Any_Collection( "Asserted Superclass: ", "Asserted Superclasses for Class '" + class_name_probe + "'",  score_assigner.get_Asserted_Superclasses( class_name_probe ) );
//		
//		System.out.println( "Number of Asserted Superclasses for Class '" + class_name_probe + "': " + score_assigner.get_Number_of_Asserted_Superclasses( class_name_probe ) );
//					
//			
//		print_Any_Collection( "Inferred Superclass: ", "Inferred Superclasses for Class '" + class_name_probe + "'",  score_assigner.get_Inferred_Superclasses( class_name_probe ) );
//
//
//		print_Any_Collection( "Asserted Subclass: ", "Asserted Subclasses for Class '" + class_name_probe + "'" , score_assigner.get_Asserted_Subclasses( class_name_probe ) );
//		
//		System.out.println( "Number of Asserted Subclasses for Class '" + class_name_probe + "': " + score_assigner.get_Number_of_Asserted_Subclasses( class_name_probe ) );
//		
//		
//		print_Any_Collection( "Inferred Subclass: ", "Inferred Subclasses for Class '" + class_name_probe + "'" , score_assigner.get_Inferred_Subclasses( class_name_probe ) );
//		
//		System.out.println( "Number of Inferred Subclasses for Class '" + class_name_probe + "': " + score_assigner.get_Number_of_Inferred_Subclasses( class_name_probe ) );
//		
//		
//		print_Any_Collection( "ASK Element: ", "All Reasoner ASK Elements", score_assigner.get_Reasoner_ASK_Elements() );
//		
//		print_Any_Collection( "TELL Element: ", "All Reasoner TELL Elements", score_assigner.get_Reasoner_TELL_Elements() );
//		
//		
//		System.out.println( "Class '" + class_name_probe + "' is subsumed by class '" + class_name_probe + "': " + score_assigner.is_Subsumed_by( thematic_role_probe, class_name_probe ) );
//		System.out.println( "Class '" + class_name_probe + "' is subsumed by class '" + thematic_role_probe + "': " + score_assigner.is_Subsumed_by( class_name_probe, thematic_role_probe ) );
//	
//		print_Any_Collection( "OWL Property: ", "All OWL Properties for the OWL Model", score_assigner.get_OWL_Properties() );
//		
//		print_Any_Collection( "RDF Instance: ", "RDF Instances in the OWL Model", score_assigner.get_Asserted_Individuals() );
//		
//		print_Any_Collection( "Restriction: ", "All Restrictions on the OWL Propery 'has_AGENT'", score_assigner.get_OWL_Restrictions( "has_AGENT" ) );
//
//		// System.out.println( "Entity '" + entity_instance_probe + "' is a valid value for relation '" + relation_probe + "' to Situation '" + situation_instance_probe Value + "': " + score_assigner.is_Valid_Property_Value( entity_instance_probe, relation_probe, situation_instance_probe ) );
//		System.out.println( "Subject '" + entity_instance_probe + "' is related to object '" + entity_instance_probe  + "' via relation '" +  relation_probe + "': " + score_assigner.is_Valid_Property_Value( entity_instance_probe, relation_probe, situation_instance_probe ) );
//		
//		
//		print_Any_Collection( "Object: ", "All Objects for Subject '" + entity_instance_probe + "' and Relation '" + relation_probe + "' ", score_assigner.list_Objects( entity_instance_probe, relation_probe ) );
//		// print_Iterator( "Subject -- Relation --> ", "All Objects for Subject -- Relation --> Object ", score_assigner.list_Objects( entity_instance_probe, relation_probe ) );
//		
//		print_Iterator( "Subject: ", "All Subjects for Relation '" + relation_probe + "'", score_assigner.list_Asserted_Subjects( relation_probe ) );
//				
//		print_Iterator( "Reference: ", "All Subject-Relation References for Object '" + entity_instance_probe + "'", score_assigner.list_All_References_to( entity_instance_probe ) );
//		
//		print_Any_Collection( "Relation: ", "All Relations between Subject '" + entity_instance_probe + "' and Object '" + situation_instance_probe + "' ", score_assigner.get_Asserted_OWL_Relations_between( entity_instance_probe, situation_instance_probe ) );
//		
//		print_Any_Collection( "Thematic Role: ", "All OWL Relations matching the Thematic Roles defined in the Configuration Script", score_assigner.get_Thematic_OWL_Relations() );
//		
//		System.out.println( "Deduced Semantic Valence for '" + situation_instance_probe + "': " + score_assigner.get_Semantic_Valence( situation_instance_probe ) );
//		
//		// print_Any_Collection( "Inferred Instantiated Class: ", "All Inferred Classes Instantiated by Individual '" + situation_instance_probe + "'", score_assigner.get_Inferred_Instantiated_Class_Names( situation_instance_probe ) );
//
//		print_Any_Collection( "Inferred AGENT: ", "All Inferred AGENTs in Context Model ", score_assigner.get_All_Inferred_Rolefillers( thematic_role_probe ) );
//		
//		print_Any_Collection( "Inferred AGENT: ", "Inferred AGENTs for situation '" + situation_instance_probe + "'", score_assigner.get_Inferred_Rolefillers_for( thematic_role_probe, situation_instance_probe ) );
//		
//		// print_Iterator( "situation Relation: ", "All situation relations between instances of entity concepts and situations", score_assigner.list_Subjects( situation_instance_probe ) );
//
//		print_Iterator( "Subject: ", "Subjects for relation 'has_Lexicalisation'" , score_assigner.list_Asserted_Subjects( "has_Lexicalisation" ) );

		
		// ==================== Methods currently not in use ==================== 
		
			/*	// This method only applies to cases in which CDG has been integrated as its own predictor.
			
				print_Any_Collection( "", "Full PPC Input from the Annotation File generated by the CDG Predicor Instance:", score_assigner.get_Sentence().get_Input_from_CDG_Predictor() );
			*/			
	}
	
		
	private void print_PPC_Output_By_Homonym()
	{
		String value = "";
		int dependant_slot_number_old = 1;
		
		for ( Word dependant : sentence.get_All_Word_Objects() )
		{
			String dependant_description = dependant.get_Description(); 
			int dependant_slot_number_new = dependant.get_Slot_Number();
			
			// Include a space between homonym blocks for improved readability.
			if ( dependant_slot_number_new != dependant_slot_number_old )	
			{
				System.out.println();
				dependant_slot_number_old = dependant_slot_number_new;
			}
			
			// Print the output header string at the beginning of each output line.
			System.out.printf( "%-60s", dependant.get_Word_String() + "  " + dependant_slot_number_new + "  " + dependant_description );

			// System.out.println( dependant.get_Word_String() + ": Word no. " + dependant.get_Position_in_Slot() );
			// System.out.println( "Description Length:" + dependant_description.length()	);
			// System.out.println( "Word Description " + dependant_description );

			for ( Word regent : sentence.get_All_Word_Objects() )
			{
				String regent_description = regent.get_Description(); 
		
				int regent_slot_number = regent.get_Slot_Number();
				
				for ( String role : thematic_roles )
				{
					value = score_assigner.get_Score( dependant_description, dependant_slot_number_new, role, regent_description, regent_slot_number );

					// System.out.println( "\nAssessing " + dependant_description + " " + dependant_slot_number_new + " " + role + " " + regent_description + " " + regent_slot_number + ":" + value + "." );

					if ( ! value.equals( "" ) )
					{
						System.out.printf( "%50s   %-15s", role + ";" + regent_slot_number + ";" + regent_description, value );
					}
//					else
//					{
//						System.out.printf( "%65s   ", "" );
//					}
//					// Commenting this block in will produce a clean matrix output with comparable row and column entries.
//					// The tidiness of the output comes at the prices of printing time and hence predictor performance, however.
				}
			}		
			
			System.out.print( "\n" );	// This forces a line break at the end of an output line of unknown length.
		}		
	}	
	
	
	private void print_PPC_Output_By_Slot()
	{
		Slot slot;
		Word word;
		int length = score_assigner.get_Sentence().get_Length();
		
		for( int i = 1; i <= length; i++)
		{
			slot = (Slot) score_assigner.get_Sentence().get_Slot_Object( i );
			/*
				Note that in the current implementation only the first word of each sentence slot is printed.
				Strictly, we need to return the plausibility scores for all homonyms and therefore would need
				to loop through each slot's words here. However, in its current implementation, CDG can only 
				accept predictions for one word (per slot) per sentence.
			*/
			
			// System.out.println( "Slot " + slot.get_Word_String() );
			word = (Word) slot.get_Word_Object( 1 );
			// System.out.printf( "%-20s %s in_context %-20s Slot_number %-20d\n", word.get_Word_String(), word.get_Prediction_String(), score_assigner.is_in_Context( word.get_Word_String() ), slot.get_Slot_Number() );
			System.out.printf( "%-30s %s\n", word.get_Word_String(), word.get_Prediction_String() );
		}
	}	
		
		
	public void print_Full_Input_From_CDG_Predictor()
	{
		/*
		String line;
		Vector input = score_assigner.get_Sentence().get_Full_Input_From_CDG_Predictor();

		int length = input.size();
				
		System.out.println( "\n============================== Full PPC Input as received in the CDG Predictor file: ==============================\n" );
		
		for( int i = 0;  i < length ; i++ )
		{
			line = (String) input.elementAt( i );
			System.out.printf( "%s%d%s%s%s", "Input Line ", i, ": \t", line, "\n" );
		}
		*/
	}	
		
		
	public void print_Class_Collection( String label, Collection <OWLClass> c )
	{
		for ( OWLClass cls : c )
		{
			System.out.println( cls );
		}
		
		System.out.println();
	}
		
	
	public void print_Any_Collection( String label, String header, Collection c )
	{
		System.out.println( "\n================================== " + header + ": ==================================\n" );
		
		try
		{
			Iterator iter = c.iterator(); 
					
			String column_width = "%-20s%s";
			
			if ( label.equals( "" ) )
			{
				column_width = "%s%s";
			}
			
			while ( iter.hasNext() )
			{
				// System.out.println( label + iter.next().toString() );
				System.out.printf( column_width, label, iter.next().toString() + "\n" );
			}
			System.out.println();
		}
		catch ( Exception e ) 
		{
			System.out.println( "The collection contained no elements to print." );
		}
	}
		
		
	public void print_Iterator( String label, String header, Iterator iter )
	{
		System.out.println( "\n================================== " + header + ": ==================================\n" );
				
		String column_width = "%-20s%s";
		
		if ( label.equals( "" ) )
		{
			column_width = "%s%s";
		}
		
		try
		{
			while ( iter.hasNext() )
			{
				System.out.printf( column_width, label, iter.next().toString() + "\n" );
			}
			System.out.println();
		}
		catch( Exception e )
		{
			System.out.println( "The iterator did not contain any printable elements." ); 
		}
	}
	
	
	public void print_Restriction_Collection( String restriction_name, Collection c )
	{
		try
		{
			Iterator iter = c.iterator(); 
			while ( iter.hasNext() )
			{
				// System.out.println( label + "\t" + ( ( OWLRestriction) iter.next() ).getFillerText() );
				System.out.println( (OWLDescription) iter.next() );
			}
		}
		catch( Exception e )
		{			
			System.out.println( "There were no restictions for property '" + restriction_name + "'." );
		}
	}
	
	
	public void set_Probes( String thematic_role, String class_name, String instance, String relation, String situation )
	{
		thematic_role_probe = thematic_role;		
		class_name_probe = class_name;	
		entity_instance_probe = instance;	
		relation_probe = relation;	
		situation_instance_probe = situation;	
	}


	public void set_Score_Assigner( Score_Assigner assigner )
	{
		score_assigner = assigner;		
	}

	
	public void set_Sentence()
	{
		sentence = score_assigner.get_Sentence();
	}
	

	public void set_Thematic_Roles()
	{
		thematic_roles = score_assigner.get_Thematic_Roles();
	}
}


