/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

%{
/* ------------------------------------------------------------------------- */
#include <config.h>
#include <cdg.h>
#include <blah.h>
#include <netsearch.h>
#include <lexemgraph.h>
#include <constraintnet.h>
#include <parse.h>
#include <command.h>
#include <incrementalcompletion.h>
#include <eval.h>
#include <scache.h>
#include <write.h>
#include <levelvalue.h>
#include <set.h>
#include <statistics.h>

  
/* ------------------------------------------------------------------------- */
%}

%init
#ifdef SWIGTCL
%{
  cdgInitialize();
  hooker_init(interp);
%}
#else
%{
  cdgInitialize();
%}
#endif

%include "cpointer.i";
%pointer_cast(Pointer, String, pointer2string);
%pointer_cast(String, Pointer, string2pointer);


%include "cdgtypemaps.i";
%include "blah.h";

#ifdef SWIGTCL
%include "hooker.i";
#endif

%mutable;
%include "cdg.h";
%immutable;

%include "command.h";
%include "input.i";
%include "lexemgraph.h";
%include "constraintnet.h";
%include "levelvalue.h";
%include "netsearch.h";
%include "incrementalcompletion.h";
%include "statistics.h";
%include "eval.h";
%include "parse.h";
%include "scache.h";
%include "set.h";
%include "write.h";

%inline %{
/* 
 This function serves the sole purpose of finding a type`s direct successors 
 in a hierarchie`s distance-table. It is (at the moment) only used by the    
 the module allhierarchies.tcl                                               
*/
List listOfSons(Hierarchy hierarchy, int position_in_Hash_List_Of_Keys)
{
  Hashtable ht = hierarchy->types;
  List keys = hashListOfKeys(ht);
  List help, sons;
  Array a = hierarchy->distance;
  int x, y;
  Pointer item;

  item = listNthElement(keys, position_in_Hash_List_Of_Keys + 1);
  /* it is necessary to add 1 to position_in_Hash_List_Of_Keys, because */
  /* the function listNthElement starts to count with one */

  x = (int)hashGet(ht, item) - 1;
  /* 'x' is the type's x-coordinate in the distance table */

  sons = NULL;
  while (keys != NULL) {
    y = (int)hashGet(ht, keys->item) - 1;
    if ((int)arrayElement(a, x, y) == 1) {
      sons = listPrependElement(sons, keys->item);
    }
    help = keys;
    keys = keys->next;
    memFree(help);
  }
  return sons;
  listDelete(keys);
}
%}

%inline %{
/*
 cast a vector access to int
*/
int intVectorElementAt(Vector v, int i)
{
  return (int)vectorElement(v, i);
}
%}

%inline %{
/*
 delete a specification
*/
void freeSpec(Specification spec) {
  cdgFreeString(spec->kind);
  cdgFreeString(spec->name);
  memFree(spec);
}
%}
