/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/**
  * @addtogroup Scorematrix
  * @{
  */

#ifndef SCOREMATRIX_H
#define SCOREMATRIX_H

#include "blah.h"

/* ---------------------------------------------------------------------- */

struct ScoreMatrixStruct;
typedef struct ScoreMatrixStruct *ScoreMatrix; 
  /**< type of matrix structure pointer */

extern Boolean smGetFlag(ScoreMatrix sm, int r, int c);
extern Boolean smSetFlag(ScoreMatrix sm, Boolean f, int r, int c);
extern ScoreMatrix smNew(int r, int c);
extern double smGetScore(ScoreMatrix sm, int r, int c);
extern double smSetScore(ScoreMatrix sm, double d, int r, int c);
extern void smDelete(ScoreMatrix sm);
extern void smSetAllFlags(ScoreMatrix sm, Boolean f);

/* ---------------------------------------------------------------------- */

#endif /* don't insert anything after this #endif */
/** @} */
