/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/* ---------------------------------------------------------------------------
 * @addtogroup Timer 
 * @{
 */

#ifndef _TIMER_H
#define _TIMER_H
#include <config.h>
#include <unistd.h>
#include <time.h>
#include <sys/resource.h>


/** a local macro to define the maximal long value */
#define MyMAXLONG ((long)~(1L << ((8 * (int)sizeof(long)) - 1)))

/* -- TYPE DEFINITIONS -------------------------------------------------- */
typedef clock_t TimerFast;    /**< the fast timer */ 
typedef struct timeval TimerStruct, *Timer; /**< the slow timer */ 

/* -- FUNCTIONS --------------------------------------------------------- */
extern void timerInitialize(void);

extern TimerFast timerStartFast();
extern unsigned long timerElapsedFast(TimerFast);

extern void timerStart(Timer);
extern Timer timerNew();
extern void timerFree(Timer);
extern unsigned long timerElapsed(Timer);

extern void timerSetAlarm(long unsigned int limit);
extern void timerStopAlarm(void);

/* -- VARIABLES --------------------------------------------------------- */
extern Boolean timerExpired;


#endif
/** @} */
