# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## DemoStatus - Status Window for DemoMode
##
## \author Bjrn Engelmann (see also AUTHORS and THANKS for more)
##-----------------------------------------------------------------------------

class DemoStatus {
	inherit ::itk::Toplevel

	constructor {args} {}; ## \type TclList
	destructor {};

	public method shell {};
	public method show {}; 
}

body DemoStatus::constructor {args} {
 
    wm withdraw $itk_interior
  
    # the shell
    itk_component add shell {
	CdgShell $itk_interior.shell \
	    -hscrollmode dynamic \
	    -wrap word
   } {
	keep -background -cursor
   }
   set _shell $itk_component(shell);

   $itk_component(shell) autotag INFO \
	-foreground black \
	-background green3 
   

   $itk_component(shell) autotag WARNING \
	-foreground black \
	-background yellow2 


   $itk_component(shell) autotag ERROR \
	-foreground white \
	-background red3 


   $itk_component(shell) autotag DEBUG \
	-foreground white \
	-background blue3 

   $itk_component(shell) autotag PROFILE \
	-foreground black \
	-background lightblue 

   #wm geometry $itk_interior [wm geometry .]
   
   pack $itk_component(shell) -fill both -side top -expand 1
   
	.cdgmain info addListener [shell]
	.cdgmain info insertCompleteStorage [shell]

	configure -title "Xcdg - Status"
	
	eval itk_initialize $args	
}

body DemoStatus::destructor {} {
	.cdgmain info removeListener [shell]
}


body DemoStatus::show {} {
   wm deiconify $itk_interior
   focus $itk_interior
}


body DemoStatus::shell {} {
	return $itk_component(shell)
}
