# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## TreeEditorParent - Interface for Parents of a TreeEditor
##
## \author Bjrn Engelmann (see also AUTHORS and THANKS for more)
##-----------------------------------------------------------------------------

class TreeEditorParent {
	
	## the TreeEditor uses this to adjust the Window Title
	public method setTitle { title }; ## \type TclString \purevirtual
	
	## the TreeEditor needs this to request the Window Title
	public method getTitle {}; ## \purevirtual
	
	## if the Parent wants to implement Undo/Redo-Functionality,
	## this Methods can be used to enable/disable the Buttons
	public method setUndo { state }; ## \type TclNumber \purevirtual
	public method setRedo { state }; ## \type TclNumber \purevirtual
	
	# this Method is used by the ParseTree Class to determine
	# the Snapping-Behaviour. possible return Values are
	# "nearest" - snap to the nearest node, this is the default
	# "best" - snap to the best node
	# "previous" - snap to the node you were previously associated with
	public method getSnapmode {}; ## \purevirtual
	
	# this Method is used by the ParseTree Class to determine
	# wheter the Tree should be drawn colored or not
	# possible return values are
	# 0 - not colored
	# 1 - colored
	public method getPaintMode {}; ## \purevirtual

};
