#!/bin/sh
# \
exec tclsh "$0" "$@" 

# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

package require Itcl
namespace import itcl::*

auto_mkindex_parser::command class {name body} {
    variable index
    variable scriptFile
    append index "set [list auto_index([fullname $name])]"
    append index " \[list source \[file join \$dir [list $scriptFile]\]\]\n"

    variable parser
    variable contextStack
    set contextStack [linsert $contextStack 0 $name]
    $parser eval $body
    set contextStack [lrange $contextStack 1 end]
}

auto_mkindex_parser::command body {name arglist body} {
    variable index
    variable scriptFile
    append index "set [list auto_index([fullname $name])]"
    append index " \[list source \[file join \$dir [list $scriptFile]\]\]\n"
}

auto_mkindex_parser::command configbody {name body} {
    variable index
    variable scriptFile
    append index "set [list auto_index([fullname $name])]"
    append index " \[list source \[file join \$dir [list $scriptFile]\]\]\n"
}

auto_mkindex_parser::command ensemble {name {body ""}} {
    variable index
    variable scriptFile
    append index "set [list auto_index([fullname $name])]"
    append index " \[list source \[file join \$dir [list $scriptFile]\]\]\n"
}


# actually the following line should work,
# but auto_mkindex seems to be buggy:
# it registers only some of the procedures
eval auto_mkindex . *.tcl

# this is the workaround for the buggy auto_mkindex:
set fileList [glob *.tcl]
foreach file $fileList {
  puts $file
  eval auto_mkindex . $file
  if {[catch {exec cat tclIndex >> tclIndex.tmp} errMsg]} {
    puts "Could not register $file in tclIndex: $errMsg"
  }
}

if {[catch {exec mv tclIndex.tmp tclIndex} errMsg]} {
  puts "Could not write tclIndex: $errMsg"
}


# successful exit
exit 0
